#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_esp8266_server/library_esp8266_4.h"
#line 17 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_esp8266_server/library_esp8266_4.h"
extern sfr sbit CH_PD;
extern sfr sbit CH_PD_Direction;
extern void UART1_Write_CText(const char *txt1);
extern char * txt;


const char AT[] = "AT";
const char ATE0[] = "ATE0";
const char AT_RST[] = "AT+RST";
const char AT_CWMODE[] = "AT+CWMODE=3";
const char AT_CIPMUX[] = "AT+CIPMUX=1";
const char AT_CIFSR[] = "AT+CIFSR";
const char AT_CWJAP[] = "AT+CWJAP=";
const char AT_CWSAP[] = "AT+CWSAP=";
const char AT_CIPSEND[] = "AT+CIPSEND=";
const char AT_CIPSERVER[]="AT+CIPSERVER=1,80";
const char AT_CIPCLOSE[] ="AT+CIPCLOSE=";
extern char ESP_ID ;
extern unsigned char *SSID_STA ;
extern unsigned char *password_STA ;
extern unsigned char *port ;
extern unsigned char *SSID_AP;
extern unsigned char *password_AP ;
extern const char chanel ;
extern const char enc ;
extern unsigned char *IP_address;
extern const char esp8266_rec_max;
extern unsigned char esp8266_received_data[];
extern void CRLF1(void);


const char ESP_OK = 1;
const char ESP_Ready_To_Receive_Message = 2;
const char ESP_ERROR = 3;
const char ESP_READY = 4;
const char ESP_FAIL = 5;
const char ESP_SEND_OK = 6;
const char ESP_no_change =7;
const char ESP_SUP =8;


char esp_state = 0;
char esp_response_rcvd = 0;
short esp_responseID = -1;
unsigned char esp_response = -1;
unsigned char esp_rsp;
unsigned char esp_i ;
unsigned char esp_DataReady_received=0;
unsigned char esp8266_len=0;
unsigned char esp8266_id=0 ;






void new_line()
{
  UART2_Write (0x0D);
  UART2_Write (0x0A);
}

 void wait_3sec()
 {
 Delay_ms(3000);
 }



 void wait_1sec()
 {
 Delay_ms(1000);
 }


void esp8266_Send(const char *s)
{

 while(*s) {
  UART2_Write (*s++);
 }


}


void esp8266_Send_Ram(char *s1)
{

 while(*s1) {
  UART2_Write (*s1++);
 }



}


short Get_Response()
{
 if (esp_response_rcvd)
 {
 esp_response_rcvd = 0;
 return esp_responseID;

 }
 else return -1;
}


void Wait_response(char rspns)
{
 char test = 1;

 while (test)
 {
 test = Get_Response();
 if ((test == rspns) || (test == ESP_ERROR))
 test = 0;
 else
 test = 1;

 }
}




void Send_ESP8266_data(const char *ESP8266_Msg_const ,char *ESP8266_Msg_ram,unsigned int len_esp_data )
{
 char buf[6];
 char * px;
 WordToStr(len_esp_data,buf);
 px=Ltrim(buf);
 UART1_Write_CText("buf=");
 UART1_Write_Text(px);CRLF1();

 esp8266_Send(AT_CIPSEND);
  UART2_Write (ESP_ID+48);
  UART2_Write (',');
 esp8266_Send_Ram(px);
 new_line();

 Delay_ms(100);
 esp8266_Send(ESP8266_Msg_const);
 esp8266_Send_Ram(ESP8266_Msg_ram);
 new_line();
 Delay_ms(50);
 Wait_response(ESP_OK);
 Delay_ms(500);
 esp8266_Send(AT_CIPCLOSE);
  UART2_Write (ESP_ID+48);
 new_line();
 Delay_ms(1500);


}

void Configuration_ESP8266()
{
 char cx;
 int n;

 UART1_Write_CText("envoi AT\r\n");
 while(1)
 {
 esp8266_Send(AT);

 new_line();
 wait_1sec();
 if (Get_Response() == ESP_OK) break;
 }

 while(1)
 {

 UART1_Write_CText("Disable Echo ATE0\r\n");
 esp8266_Send(ATE0);
 new_line();
 wait_1sec();
 if (Get_Response() == ESP_OK) break;
 }



 UART1_Write_CText("Reset WIFI3  AT_RST\r\n");
 while(1)
 {
 esp8266_Send(AT_RST);
 new_line();
 wait_1sec();
 if (Get_Response() == ESP_READY) break;
 }



 UART1_Write_CText("Set AT_CWMode Mixte= 3\r\n");
 esp_state=0;
 n=0;
 while(1)
 {
 esp8266_Send(AT_CWMODE);
 new_line();
 wait_1sec();
 cx= Get_Response() ;
 if ((cx== ESP_OK ) ||( cx== ESP_no_change )) break;


 n++;
 if (n>3) break;
 }



UART1_Write_CText("Set Multiple connections\r\n");
 while(1)
 {
 esp8266_Send(AT_CIPMUX);
 new_line();
 wait_1sec();
 if (Get_Response() == ESP_OK) break;
 }
#line 259 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_esp8266_server/library_esp8266_4.h"
 UART1_Write_CText("Parametrage d'acces ESP8266 Serveur au resau Wifi : \r\n");


 UART1_Write_CText("SSID : ");UART1_Write_Text(SSID_AP);CRLF1(); UART1_Write( 9 );
 UART1_Write_CText("Password : ");UART1_Write_Text(password_AP);CRLF1();UART1_Write( 9 );
 UART1_Write_CText("# Chanel :");UART1_Write(chanel+48);CRLF1();UART1_Write( 9 );
 UART1_Write_CText("Mode Encodage :");UART1_Write(enc+48);CRLF1() ;
 CRLF1();

 do {

 esp8266_Send(AT_CWSAP);
  UART2_Write ('"');
 esp8266_Send_Ram(SSID_AP);
  UART2_Write ('"');
  UART2_Write (',');
  UART2_Write ('"');
 esp8266_Send_Ram(password_AP);
  UART2_Write ('"');
  UART2_Write (',');
  UART2_Write (chanel+48);
  UART2_Write (',');
  UART2_Write (enc+48);
 new_line();
 wait_3sec();
 } while(Get_Response() != ESP_OK);


 UART1_Write_CText("Connection au Server  \r\n");
 do {

 esp8266_Send(AT_CIPSERVER);
 new_line();
 wait_3sec();
 } while(Get_Response() != ESP_OK);

}


void esp8266_read_message()
{
 char esp_tmp;
 esp_tmp =  UART2_Read ();

 TXREG1=esp_tmp;


 switch (esp_state)
 {
 case 0: {
 esp_response = -1;
 if (esp_tmp == 'O')
 esp_state = 1;

 else if (esp_tmp == 'E')
 esp_state = 10;

 else if (esp_tmp == 'r')
 esp_state = 20;

 else if(esp_tmp == 'F')
 esp_state = 30;






 else if(esp_tmp == 'n')
 esp_state = 40;

 else if (esp_tmp == '+')
 esp_state = 100;







 break;
 }

 case 1: {
 if (esp_tmp == 'K')
 {
 esp_response = ESP_OK;
 esp_state = 2;
 }
 else
 esp_state = 0;
 break;
 }

 case 10: {
 if (esp_tmp == 'R')
 esp_state = 11;
 else
 esp_state = 0;
 break;
 }

 case 11: {
 if (esp_tmp == 'R')
 esp_state = 12;
 else
 esp_state = 0;
 break;
 }

 case 12: {
 if (esp_tmp == 'O')
 esp_state = 13;
 else
 esp_state = 0;
 break;
 }

 case 13: {
 if (esp_tmp == 'R')
 {
 esp_response = ESP_ERROR;
 esp_state = 2;
 }
 else
 esp_state = 0;
 break;
 }

 case 20: {
 if (esp_tmp == 'e')
 esp_state = 21;
 else
 esp_state = 0;
 break;
 }

 case 21: {
 if (esp_tmp == 'a')
 esp_state = 22;
 else
 esp_state = 0;
 break;
 }

 case 22: {
 if (esp_tmp == 'd')
 esp_state = 23;
 else
 esp_state = 0;
 break;
 }


 case 23: {
 if (esp_tmp == 'y')
 {
 esp_response = ESP_READY;
 esp_state = 2;
 }
 else
 esp_state = 0;
 break;
 }

 case 30: {
 if (esp_tmp == 'A')
 esp_state = 31;
 else
 esp_state = 0;
 break;
 }

 case 31: {
 if (esp_tmp == 'I')
 esp_state = 32;
 else
 esp_state = 0;
 break;
 }

 case 32: {
 if (esp_tmp == 'L')
 {
 esp_response = ESP_FAIL;
 esp_state = 2;
 }
 else
 esp_state = 0;
 break;
 }



 case 40: {
 if (esp_tmp == 'o')
 esp_state = 41;
 else
 esp_state = 0;
 break;
 }

 case 41: {
 if (esp_tmp == ' ')
 esp_state = 42;
 else
 esp_state = 0;
 break;
 }
 case 42: {
 if (esp_tmp == 'c')
 esp_state = 43;
 else
 esp_state = 0;
 break;
 }
 case 43: {
 if (esp_tmp == 'h')
 esp_state = 44;
 else
 esp_state = 0;
 break;
 }
 case 44: {
 if (esp_tmp == 'a')
 esp_state = 45;
 else
 esp_state = 0;
 break;
 }
 case 45: {
 if (esp_tmp == 'n')
 esp_state = 46;
 else
 esp_state = 0;
 break;
 }
 case 46: {
 if (esp_tmp == 'g')
 esp_state = 47;
 else
 esp_state = 0;
 break;
 }
 case 47: {
 if (esp_tmp == 'e')
 {
 esp_response = ESP_no_change;
 esp_state = 2;
 }
 else
 esp_state = 0;
 break;
 }


 case 100 : {

 if(esp_tmp == 'I')esp_state = 101;

 else esp_state = 0;
 break;
 }

 case 101 : {
 if(esp_tmp == 'P')esp_state = 102;

 else esp_state = 0;
 break;
 }
 case 102 : {
 if(esp_tmp == 'D')esp_state = 103;

 else esp_state = 0;
 break;
 }
 case 103 : {
 if(esp_tmp == ',' )
 {
 esp_state=104;
 }

 else esp_state=0;
 break;
 }
 case 104 : {
 if(esp_tmp>='0' && esp_tmp<='5')
 {
 esp8266_id=esp_tmp-'0';
 esp_state=105;
 }
 else esp_state=0;
 break;
 }

 case 105 : {



 if(esp_tmp !=':' )
 {
 esp_state=105;

 }

 else
 {


 esp_i=0;
 esp8266_received_data[0]=0;
 esp_DataReady_received=0;
 esp_state=106;

 }
 break;
 }

 case 106 : {



 if(esp_tmp !='H' )
 {
 esp_i++;
 if(esp_i>esp8266_rec_max)
 {
 esp_i=esp8266_rec_max;
 }
 else
 {


 esp8266_received_data[esp_i-1] = esp_tmp;
 }
 }
 else
 {





 esp_DataReady_received=1;


 esp8266_received_data[esp_i ]=0;




 esp_state=0;
 }
 break;
 }
 case 2: {

 if (esp_tmp == 13)esp_state = 3;
 else esp_state = 0;
 break;
 }

 case 3: {
 if (esp_tmp == 10)
 {
 esp_response_rcvd = 1;
 esp_responseID = esp_response;
 esp_state = 0;
 }
 else esp_state = 0;
 break;
 }

 default: {
 esp_state = 0;
 break;
 }
 }
 }
#line 67 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
sbit LD1 at LATD4_bit;
sbit LD2 at LATE4_bit;
sbit LD1_Direction at TRISD4_bit;
sbit LD2_Direction at TRISE4_bit;



sbit BP1 at RD7_bit;
sbit BP2 at RH3_bit;
sbit BP1_Direction at TRISD7_bit;
sbit BP2_Direction at TRISH3_bit;

sbit Scope_Bit at LATH5_bit;
sbit Scope_Bit_Direction at LATH5_bit;


sbit CH_PD at LATA2_bit;
sbit CH_PD_Direction at LATA2_bit;
sbit GPIO15 at LATE1_bit;
sbit GPIO15_Direction at LATE1_bit;



unsigned char buffer1[ 256 ];

unsigned int i,j,k,l,m;
int m0,m1;
unsigned int Index1=0;
unsigned int i1=0;
unsigned int UART1_DataReady=0;
unsigned char c1=0;
float f1,f2;

char TEXTE[128];
char *txt;
char *px;
char CRam1[64];
unsigned char addr;

unsigned char volt[6];
unsigned int Count;
int t;

unsigned char tmp,c2;
int UART2_DataReady;
unsigned int i2,Index2;

unsigned char cx;
unsigned int Pointeurs_Dieses[6];
char Run_Once=0;
unsigned int WebPageLen=0;
int Pointeur_Volt=0;
int Pointeur_Count=0;
char Compte[6];
volatile int Flag_Timer0;
volatile unsigned int Cpt0;
volatile int Flag_Timer1;
volatile unsigned int Cpt1;


unsigned char *SSID_AP = "ESP8266";
unsigned char *password_AP = "ESP12345";
unsigned char *IP_address="192.168.4.1";

const char chanel = 4;
const char enc = 4;
char ESP_ID =0;
unsigned int Do_ReFresch=0;
const char esp8266_rec_max=16;

unsigned char esp8266_received_data[esp8266_rec_max+1];


char interrupt_detected=0;
#line 151 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
const char indexPage1[] =
#line 169 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
"<html><meta http-equiv=\"Content-Type\"content=\"text/html; charset=iso-8859-1\"><meta http-equiv=\"refresh\" content=\"10;url=http://192.168.0.103\"><head><title>test ESP8266 serveur</title></head><body bgcolor=\"#FFFFFF\"><h2 align=\"center\"><font size=\"6\" color=\"#0066FF\"> Test Wifi3 avec clicker2 PIC18F87J50</font></h2><form action=\"\" method=\"get\" name=\"paulo \"><table width=\"200\" border=\"2\" align=\"center\" cellpadding=\"2\" cellspacing=\"3\"><tr><td colspan=3 bgcolor=#000000><marquee behavior=alternate direction=left scrollamount=10><font color=#00FF33>  Paulfjujo.free.fr </font></marquee></td></tr><td width=\"200\">Led 1</td>";
#line 172 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
char indexPage2[]=
#line 189 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
"<td bgcolor=#CCFF00><center><input name=\"Led1\" width=\"200\" type=\"submit\" value=\"D4on\"/></center></td><td bgcolor=#FF0000><center><input name=\"Led1\" width=\"200\" type=\"submit\" value=\"D4off\"/></center></td></tr> <tr> <td width=\"200\">Led 2</td><td bgcolor=#CCFF00><center><input name=\"Led2\" width=\"200\" type=\"submit\" value=\"E4on\"/></center></td><td bgcolor=#FF0000><center><input name=\"Led2\" width=\"200\" type=\"submit\" value=\"E4off\"/></center></td></tr><tr><td width=\"200\">Volt </td><td colspan=2>@     V</td></tr><tr><td width=\"200\">Count</td><td colspan=2>     </td></tr></table></form></body></html>";
#line 196 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
void strConstRamCpy(char *dest, const char *source);

void LCD_CLS(void);
void LCD_Clear(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void) ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);
unsigned char check_device(unsigned char dev_address);
void UART1_Write_CText(const char *txt1);
void CRLF1(void) ;
void RAZ_UART1(void);
void Search_Pointeurs(void);
void InitTimer0(void);
void Init_Timer1(unsigned int Max);
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_esp8266_server/lcd2119.inc"






void LCD_CLS()
{

LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}
#line 31 "c:/_mikroc/_mesprojets_mikroc/_18f87j50_esp8266_server/lcd2119.inc"
int LCD2119_Init(void)
{

int j,k;
k=0;
Delay_ms(500);
I2C2_Start();
j=I2C2_Wr( 0x74 );
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2C2_Wr(0x00);
if (j>0) return k;
k++;
I2C2_Wr(0x24);
I2C2_Wr(0x0C);
I2C2_Wr(0x06);
I2C2_Wr(0x25);

I2C2_Wr(0x06);
I2C2_Wr(0x11);
I2C2_Wr(0x42);

I2C2_Wr(0x96);
j=I2C2_Wr(0x24);
if (j>0) return k;
k++;
j=I2C2_Wr(0x0C);
if (j>0) return k;
k++;
j=I2C2_Wr(0x06);
if (j>0) return k;
k++;
j=I2C2_Wr(0x02);
if (j>0) return k;
k++;


j=I2C2_Wr(0x01);
if (j>0) return k;
Delay_ms(100);
I2C2_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{ int i;
 I2C2_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);
 I2C2_Wr(0x02);
 switch (L)
 {
 case 1:
 I2C2_Wr(0x80);
 break;
 case 2:
 I2C2_Wr(0xC0);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x40);
 for (i=0;i<39;i++)
 {
 I2C2_Wr(0x80+32);
 }

 I2C2_Repeated_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);

 switch (L)
 {
 case 1:
 I2C2_Wr(0x80);
 break;
 case 2:
 I2C2_Wr(0xC0);
 break;
 default:
 break ;
 }
 I2C2_Stop();
}


void LCD_Write_CText(const char * t1)
 {
 char TT[17];
 int i;
 strConstRamCpy(TT,t1);
 I2C2_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);
 I2C2_Repeated_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x40);
 i=0;
 while(*(t1))
 {
 I2C2_Wr(0x80+*(t1));
 t1++;
 i++;
 if (i>16) break;
 }
 I2C2_Stop();
}


void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
 char TT[17];
 int i;
 strConstRamCpy(TT,t1);
 I2C2_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x40);
 i=0;
 while(*(t1))
 {
 I2C2_Wr(0x80+*(t1));
 t1++;
 i++;
 if (i>16) break;
 }
 I2C2_Stop();
}



void LCD_Write_Chr_At(int Ligne,int col,char c1)
{


 I2C2_Start() ;
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start() ;
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x40);
 I2C2_Wr(0x80+c1);
 Delay_ms(10);
 I2C2_Stop();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{

 int i;
 I2C2_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x00);
 if(col>16) col=16;
 switch (Ligne)
 {
 case 1:
 I2C2_Wr(0x80+col-1);
 break;
 case 2:
 I2C2_Wr(0xc0+col-1);
 break;
 default:
 break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr( 0x74 );
 I2C2_Wr(0x40);
 i=0;
 while(*(t1))
 {
 I2C2_Wr(0x80+*(t1));
 t1++;
 i++;
 if (i>16) break;
 }
 I2C2_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
 LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C2_Start();
 I2C2_Wr(0x76);
 I2C2_Wr(0x00);
 I2C2_Wr(Cde);
 I2C2_Stop();
}

void LCD_Gauche()
{
 LCD_Cde(0x010);
 }


unsigned char check_device(unsigned char dev_address)
{
char Etat;
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2C2_Start();
if(I2C2_Wr(dev_address)!=0 )
 {
 UART1_Write_CText(" is not found\r\n");
 Etat=0;
 }
 else
 {
 UART1_Write_CText(" found OK\r\n");
 Etat=1;
 }
I2C2_Stop();
 return Etat;
}
#line 225 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
void interrupt() iv 0x0008 ics ICS_AUTO
{
 if (RC2IF_bit == 1)
 {
 Scope_Bit=1 ;
 esp8266_read_message();




 Scope_Bit=0;
 }
 else
 {
 if (TMR0IF_bit==1)
 {
 TMR0H = 0x48;
 TMR0L = 0xE5;
 Cpt0++;
 if (Cpt0>8)
 {
 Flag_Timer0=1;
 TMR0ON_bit=0;
 TMR0IE_bit=0;
 }
 TMR0IF_bit = 0;
 }
 }

 if ((TMR1IF_bit==1) &&( TMR1IE_bit==1))
 {
 TMR1IF_bit = 0;

 TMR1H = 0x6D;
 TMR1L = 0x84;
 Cpt1--;

 if (Cpt1==0)
 {
 Flag_Timer1=1 ;
 TMR1ON_bit=0;
 TMR0IE_bit=0;
 }
 TMR1IF_bit = 0;
 }

 if(INT2IF_bit==1)
 {
 INT2IF_bit=0;
 interrupt_detected=1;
 }
 }


 void Init_INT2(void)
 {

TRISB2_bit=1;

INT2IF_bit = 0;
INT2IE_bit=1;
INT2IP_bit=1;
INTEDG2_bit=1;
GIEH_bit=1;
RBPU_bit=1;




}




void InitTimer0(void)
{
 T0CON = 0x87;
 TMR0H = 0x48;
 TMR0L = 0xE5;
 Flag_Timer0=0;
 TMR0IE_bit=1;
 Cpt0=0;
}




void Init_Timer1(unsigned int Max)
{
 T1CON = 0x00;
 RD16_bit=1;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 TMR1CS_bit=0 ;
 TMR1H = 0x6D;
 TMR1L = 0x84;
 Cpt1=Max;
 Flag_Timer1=0;
 RCON.IPEN=1;
 TMR1IP_bit=1;
 TMR1IF_bit = 0;
 TMR1IE_bit = 1;
 TMR1ON_bit=1;
}


void Float2Ascii (float x, unsigned char *str,char precision)
{


 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}


void Search_Pointeurs(void)
{
 k=sizeof(indexPage1);
 UART1_Write_CText("Long page1 en ROM= ");
 WordToStr(k,txt);
 UART1_Write_Text(txt);UART1_Write( 9 );
 k=sizeof(indexPage2);
 UART1_Write_CText("Long page2 en RAM= ");
 WordToStr(k,txt);
 UART1_Write_Text(txt);
 CRLF1();

 CRLF1();
 UART1_Write_CText("\r\nRecherche @ et #(dieses) char by char \r\nindexpage2 AVANT mise  jour:\r\n");
 j=0;
 k=strlen(indexPage2);
 for (i=0;i<k;i++)
 {
 cx=indexPage2[i];
 if (cx=='@') Pointeur_Volt=i;
 if (cx=='') Pointeur_Count=i;
 if (cx=='#')
 {
 Pointeurs_Dieses[j]=i;
 j++;
 if (j>5)
 {
 UART1_Write_CText("\r\nErreur pointeur dieses !\r\n");
 while(1);
 }
 }
 UART1_Write(cx);
 }

 CRLF1();
 for (j=0;j<4;j++)
 {
 UART1_Write_CText("\r\nPointeur dieses #");
 UART1_Write(j+48);
 UART1_Write( 9 );
 WordToStr(Pointeurs_Dieses[j],txt);
 UART1_Write_Text(txt);
 }
 UART1_Write_CText("\r\nPointeur Volt : ");
 WordToStr(Pointeur_Volt,txt);
 UART1_Write_Text(txt);
 UART1_Write_CText("\r\nPointeur Count : ");
 WordToStr(Pointeur_Count,txt);
 UART1_Write_Text(txt);
 CRLF1();

 CRLF1();
 }

void ESP8266_UserTCP()

 {
 int j;



 if(memcmp(esp8266_received_data+11, "D4on", 4)==0)
 LD1=1;
 else
 if(memcmp(esp8266_received_data+11, "D4off", 5)==0)
 LD1=0;
 if(!memcmp(esp8266_received_data+11, "E4on", 4))
 LD2=1;
 else
 if(!memcmp(esp8266_received_data+11, "E4off", 5))
 LD2=0;
 else
 if(!memcmp(esp8266_received_data+11, "  / ", 4))
 Do_ReFresch=1;


 memcpy(indexPage2+Pointeur_Volt,volt, 4);



 memcpy(indexPage2+Pointeur_Count,Compte, 5);



 UART1_Write_CText("Reception data from pageWeb:\r\n");
 UART1_Write_Text( esp8266_received_data);
 CRLF1();



if (LD1)
 {
 memcpy(indexPage2+Pointeurs_Dieses[0], "#00FF00", 6);
 memcpy(indexPage2+Pointeurs_Dieses[1], "#FF0000", 6);
 }
 else
 {
 memcpy(indexPage2+Pointeurs_Dieses[0], "#FF0000", 6);
 memcpy(indexPage2+Pointeurs_Dieses[1], "#00FF00", 6);
 }
if (LD2)
 {
 memcpy(indexPage2+Pointeurs_Dieses[2], "#00FF00", 6);
 memcpy(indexPage2+Pointeurs_Dieses[3], "#FF0000", 6);
 }
 else
 {
 memcpy(indexPage2+Pointeurs_Dieses[2], "#FF0000", 6);
 memcpy(indexPage2+Pointeurs_Dieses[3], "#00FF00", 6);
 }

 if(Run_Once==0)
 {
 CRLF1();
 UART1_Write_CText("\r\nListe indexpage1:\r\n");
 k=sizeof(indexPage1);
 for (i=0;i< k;i++)
 {
 cx=indexPage1[i];
 UART1_Write(cx);
 }
 CRLF1();
 CRLF1();

 CRLF1();
 UART1_Write_CText("\r\nListe indexpage2 APRES mise  jour:\r\n");
 for (i=0;i< strlen(indexPage2);i++) UART1_Write(indexPage2[i]);
 CRLF1();
 CRLF1();

 k=sizeof(indexPage1);
 UART1_Write_CText("Long page1 en ROM= ");
 WordToStr(k,txt);
 UART1_Write_Text(txt);UART1_Write( 9 );
 m=sizeof(indexPage2);
 UART1_Write_CText("Long page2 en RAM= ");
 WordToStr(m,txt);
 UART1_Write_Text(txt);
 CRLF1();
 WebPageLen=k+m;
 Run_Once=1;
 }

 Send_ESP8266_data(indexPage1,indexPage2,WebPageLen);


}




void strConstRamCpy(char *dest, const char *source)
{
 while(*source) *dest++ = *source++ ;
 *dest = 0 ;
}


void UART1_Write_CText(const char *txt1)
 {
 while (*txt1)
 UART1_Write(*txt1++);
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
 }

 void RAZ_UART1()
{ RC1IE_bit=0 ;
 for (Index1=0;Index1< 256 ;Index1++) buffer1[Index1]=0;
 Index1=0;
 i1=0;
 UART1_DataReady=0;
 c1=0;
 RC1IE_bit=1 ;
}


void Hardware_Init(void)
 {
 TRISG=0xFF;
 TRISA=0xFF;
 TRISB=0xFF ;
 TRISC=0xFF;
 TRISD=0xFD;
 TRISE=0xFF;
 TRISH=0xFF;

 ANCON0=0xFD ;
 ANCON1=0xFF;
 Scope_Bit_Direction=0;

 BP1_Direction = 1;
 BP2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 CH_PD_Direction=0;

 GPIO15_Direction=0;
 }



void main()
{

 Hardware_Init();

 UART1_Init(19200);

 txt=&TEXTE[0];
 UART1_Write( 12 );
 Delay_ms(500);
 CRLF1();
 UART1_Write_CText( "C:\\_MikroC\_MesProjets_MikroC\_18F87J50_ESP8266_Server" "\r\n");
 UART1_Write_CText("Projet : " "ESP8266_server_1605.mcppi" "\r\n");
 UART1_Write_CText( "18F87J50_ESP8266_server" "_" "160523" ".c\r\n");
 UART1_Write_CText("18F87J50 FOSC=48MHz \\r\n");
 UART1_Write_CText("LCD2119 en I2C2\r\n");
 UART1_Write_CText("RA1= Analog input\r\n");
 UART1_Write_CText("Leds  LD1=RD4  LD2=RE4\r\n");
 UART1_Write_CText("BPs   BP1=RD7  BP2=RH3\r\n");
 UART1_Write_CText("\r\nInit I2C2 at 400Khz\r\n");

 LD1=1;
 I2C2_Init(400000);
 CRLF1();
 LD1=0;
 Run_Once=0;
 Count=65520;
 Flag_Timer0=0;
 Cpt0=0;
 Flag_Timer1=0;
 Cpt1=0;

 addr= 0x74 ;
 k=check_device(addr) ;
 CRLF1();

 k=LCD2119_Init();
 Delay_ms(50);
 LCD_CLS();
 Delay_ms(50);

 ADC_Init();



 LCD_Write_CText_At(1,1,"18F87J50 F=48Mz");
 LCD_Write_CText_At(2,1,"LCD2119 en I2C2");
 Delay_ms(1500);
 LCD_Write_CText_At(1,1,"MikroC 6.62 1605");

 Delay_ms(2000);
 CRLF1();

 UART2_Init(19200);
 UART_Set_Active(&UART2_Read, &UART2_Write, &UART2_Data_Ready, &UART2_Tx_Idle);

 Delay_ms(300);

 UART1_Write_CText("Init Wifi3 Power ON\r\n" );
 LCD_Write_CText_At(2,1,"Power ON Wifi3  ");

 CH_PD=0;
 GPIO15=0;


 PEIE_bit = 1;
 GIE_bit = 1;


 CRLF1();
 UART1_Write('#');
 CRLF1();





 Delay_ms(5000);
 CRLF1();
 UART1_Write('&');
 LCD_Write_CText_At(2,1,"Init Module Wifi");

 CRLF1();
 Init_Timer1(100);
 while(Flag_Timer1==0);

 CRLF1();
 UART1_Write('$');
 CRLF1();

 CH_PD= 1;
 GPIO15=1;

 RC2IE_bit = 1;
 LCD_RAZ_Ligne(2);
 LCD_Write_CText_At(1,1,"Config ESP8266  ");

 Configuration_ESP8266();

 LD1=1;
 LCD_Write_CText_At(2,1,"   CONNECTED   ");
 Delay_ms(1000);
 LCD_CLS();

 LD1 = 0;
 LD2 = 0;

 if(Run_Once==0) Search_Pointeurs();

 while(1)
 {


 Init_Timer1(400);
#line 710 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
 LCD_CLS();
 if(esp_DataReady_received)
 {

 LCD_Write_CText_At(1,1,"ID=");
 UART1_Write_CText("\r\n ID=");
 UART1_Write(esp8266_id); CRLF1();
 LCD_Write_Chr_At(1,4,esp8266_id+48);
 LCD_Write_CText_At(2,1,"DATA:");









 for (j=0;j<esp_i-6;j++)
 LCD_Write_Chr_At(2,j+6,esp8266_received_data[j+6]);

 esp_DataReady_received=0;


 Delay_ms(1000);
 ESP8266_UserTCP();



 }


 sprintf(txt,"Led1= %1c  Led2= %1c",LD1+48,LD2+48);
 LCD_Write_Text_At(1,1,txt);
 t=ADC_Read(1);
 f1=(float)t *3.22265625;
 t = (unsigned int) f1;
 volt[0]=((t/1000)%10)+48;
 volt[1]='.' ;
 volt[2]=((t/100)%10) +48;
 volt[3]=((t/10)%10) +48;

 volt[4]=0;
 sprintf(txt,"EA1 = %s Volts",volt);
 UART1_Write_Text(txt); CRLF1();
 LCD_Write_Text_At(2,1,txt);
 Count++;
 WordToStr(Count,Compte) ;
 UART1_Write_CText("Counts = ");
 UART1_Write_Text(Compte); CRLF1();



 while(Flag_Timer1==0);
#line 768 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_ESP8266_Server/18F87J50_ESP8266_server_160523.c"
 }
}
