
// 23 mai 2016


 // rev 21 mai 2016
 // correction esp_state=2  (was 7 ?? sur reception complete de "no_change"
// rev 15 mai 2016
// rajout test no change

#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define Bell 7

extern sfr sbit CH_PD;      // resert pin
extern sfr sbit CH_PD_Direction;
extern void UART1_Write_CText(const char *txt1);
extern char * txt;

// Set of basic AT commands
const char   AT[]        = "AT"; // startupTest AT startup
const char ATE0[]        = "ATE0";//Disable echo
const char AT_RST[]      = "AT+RST";//Restart module
const char AT_CWMODE[]   = "AT+CWMODE=3";//WIFI mode (station/softAP/station+softAP) now choice station+softAP
const char AT_CIPMUX[]   = "AT+CIPMUX=1";//Set multiple connections mode
const char AT_CIFSR[]    = "AT+CIFSR";//Get local IP address
const char AT_CWJAP[]    = "AT+CWJAP=";// Connect to AP.
const char AT_CWSAP[]    = "AT+CWSAP=";//Set parameters under AP mode
const char AT_CIPSEND[]  = "AT+CIPSEND=";//Send data
const char AT_CIPSERVER[]="AT+CIPSERVER=1,80";//create server and using port 80.
const char AT_CIPCLOSE[] ="AT+CIPCLOSE=";//disconnection .
extern char ESP_ID ;
extern unsigned char *SSID_STA ;
extern unsigned char *password_STA ;
extern unsigned char *port ;
extern unsigned char *SSID_AP;
extern unsigned char *password_AP ;
extern const char chanel ;
extern const char enc ;
extern unsigned char *IP_address;
extern const char esp8266_rec_max;
extern unsigned char esp8266_received_data[];
extern void CRLF1(void);
//
// Responses to parse
const char ESP_OK                        = 1;
const char ESP_Ready_To_Receive_Message = 2;
const char ESP_ERROR                    = 3;
const char ESP_READY                    = 4;
const char ESP_FAIL                     = 5;
const char ESP_SEND_OK                  = 6;
const char ESP_no_change                 =7;
const char ESP_SUP                       =8; // > aores AT+CIPSEND=ID,Size<CR><LF>

// State machine control variables
char esp_state = 0;
char esp_response_rcvd = 0;
short esp_responseID = -1;
unsigned char esp_response = -1;
unsigned char esp_rsp;
unsigned char  esp_i ;
unsigned char esp_DataReady_received=0;
unsigned char esp8266_len=0;
unsigned char esp8266_id=0  ;

#define UART_Wr_Ptr   UART2_Write
#define UART_Rd_Ptr   UART2_Read


// ********************* //
void new_line()
{
 UART_Wr_Ptr(0x0D);
 UART_Wr_Ptr(0x0A);
}
 // ***********************//
 void wait_3sec()
 {
  Delay_ms(3000);
 }
 
 //********************
  //
 void wait_1sec()
 {
  Delay_ms(1000);
 }
 //****************
// Send command or data to the esp8266  Module - (const)
void esp8266_Send(const char *s)
{
// Send command or data string
   while(*s) {
    UART_Wr_Ptr(*s++);
   }
// Terminatation by CR+LF

}

// Send command or data to the esp8266  Module - (RAM)
void esp8266_Send_Ram(char *s1)   //
{
// Send command or data string
   while(*s1) {
    UART_Wr_Ptr(*s1++);
   }
// Terminatation by CR
   //UART_Wr_Ptr(0x0D);
   //UART_Wr_Ptr(0x0D);
}

// Get esp8266  response, if there is any
short Get_Response()
{
    if (esp_response_rcvd)
      {
      esp_response_rcvd = 0;
      return esp_responseID;
      //return esp_response;
     }
    else  return -1;
}

// Wait for esp8266 response (infinite loop)
void Wait_response(char rspns)
{
 char test = 1;

  while (test)
    {
     test = Get_Response();
     if ((test == rspns) || (test == ESP_ERROR))
     test = 0;
     else
     test = 1;

    }
}


//*****************************************************************//
// Send Status data
void Send_ESP8266_data(const char *ESP8266_Msg_const ,char *ESP8266_Msg_ram,unsigned int len_esp_data  )
{
  char buf[6];
  char * px;
  WordToStr(len_esp_data,buf);
  px=Ltrim(buf);
  UART1_Write_CText("buf=");
  UART1_Write_Text(px);CRLF1();
  
  esp8266_Send(AT_CIPSEND); // send commands "AT+CIPSEND="
  UART_Wr_Ptr(ESP_ID+48);// send ID.
  UART_Wr_Ptr(',');
  esp8266_Send_Ram(px);
  new_line(); //CR+LF .  // utile ou pas ???
  //Wait_response(ESP_SUP); // Wait for >
  Delay_ms(100);
  esp8266_Send(ESP8266_Msg_const);               // Send data content
  esp8266_Send_Ram(ESP8266_Msg_ram);               // Send data content
  new_line(); //CR+LF .
  Delay_ms(50);
  Wait_response(ESP_OK);      // Wait SEND OK as confirmation that the message was sent
   Delay_ms(500);
    esp8266_Send(AT_CIPCLOSE); // Send "AT+CIPCLOSE="
    UART_Wr_Ptr(ESP_ID+48);// send ID.
    new_line();
    Delay_ms(1500);


}
//**************************************************************//
void Configuration_ESP8266()
{
   char cx;
   int n;
// Negotiate baud rate
  UART1_Write_CText("envoi AT\r\n");
  while(1)
  {
    esp8266_Send(AT);                 // Send "AT" string until ESP8266 sets up its baud rade

    new_line();
    wait_1sec();                    // and gets it correctly
    if (Get_Response() == ESP_OK) break;    // If esp8266 says "OK" on our baud rate we program can continue
  }
 //****************************************************//
  while(1)
  {
  
   UART1_Write_CText("Disable Echo ATE0\r\n");
  esp8266_Send(ATE0);        // Disable command echo
  new_line();
  wait_1sec();
    if (Get_Response() == ESP_OK) break;    // If esp8266 says "OK" on our baud rate we program can continue
  }
  
 // Wait_response(ESP_OK);
 //****************************************************//
  UART1_Write_CText("Reset WIFI3  AT_RST\r\n");
  while(1)
  {
    esp8266_Send(AT_RST);                 // Send "RST" reset module
    new_line();
    wait_1sec();                   // and gets it correctly
    if (Get_Response() == ESP_READY) break;    // If esp8266 says "ready" on our baud rate we program can continue
  }
 //****************************************************//
 

 UART1_Write_CText("Set AT_CWMode Mixte= 3\r\n");
 esp_state=0;
 n=0;
  while(1)
  {
    esp8266_Send(AT_CWMODE);                // set wifi mode 1-station  2- access point 3- station+access point
    new_line();
    wait_1sec();                    // and gets it correctly
   cx= Get_Response() ;
   if ((cx== ESP_OK ) ||( cx== ESP_no_change )) break;
   // probleme sur ce test !
   //  break;
   n++;
   if (n>3) break;
  }
  

//****************************************************//
UART1_Write_CText("Set Multiple connections\r\n");
    while(1)
  {
    esp8266_Send(AT_CIPMUX);                 // Set multiple connections mode
    new_line();
    wait_1sec();                    // and gets it correctly
    if (Get_Response() == ESP_OK) break;    // If esp8266 says "OK" on our baud rate we program can continue
  }
 //****************************************************//
 /*   UART1_Write_CText("Connection au resau Wifi \r\n");
   do {      // connected with your network
     UART1_Write_CText("Connection au resau Wifi \r\n");
     //AT+CWJAP="SSID","pasword" <CR><LF>
     esp8266_Send(AT_CWJAP);
     UART_Wr_Ptr('"');
     esp8266_Send_Ram(SSID_STA);
     UART1_Write_Text(SSID_STA);CRLF1();
     UART_Wr_Ptr('"');
     UART_Wr_Ptr(',');
     UART_Wr_Ptr('"');
     esp8266_Send_Ram(password_STA);
     UART1_Write_Text(password_STA);CRLF1();
     UART_Wr_Ptr('"');
     new_line();
     wait_3sec();
  } while(Get_Response() != ESP_OK);
  */
 //****************************************************//
     UART1_Write_CText("Parametrage d'acces ESP8266 Serveur au resau Wifi : \r\n");
     //UART1_Write_Text(SSID_STA);CRLF1();
     //  UART1_Write_Text(password_STA);CRLF1();
     UART1_Write_CText("SSID : ");UART1_Write_Text(SSID_AP);CRLF1(); UART1_Write(TAB);
      UART1_Write_CText("Password : ");UART1_Write_Text(password_AP);CRLF1();UART1_Write(TAB);
     UART1_Write_CText("# Chanel :");UART1_Write(chanel+48);CRLF1();UART1_Write(TAB);
      UART1_Write_CText("Mode Encodage :");UART1_Write(enc+48);CRLF1() ;
      CRLF1();
     
  do { // set parameter for access point
     //AT+CWSAP="SSID","pasword" , port,port,mode, <CR><LF>
     esp8266_Send(AT_CWSAP);
     UART_Wr_Ptr('"');
     esp8266_Send_Ram(SSID_AP);
     UART_Wr_Ptr('"');
     UART_Wr_Ptr(',');
     UART_Wr_Ptr('"');
     esp8266_Send_Ram(password_AP);
     UART_Wr_Ptr('"');
     UART_Wr_Ptr(',');
     UART_Wr_Ptr(chanel+48);
     UART_Wr_Ptr(',');
     UART_Wr_Ptr(enc+48);
     new_line();
     wait_3sec();
  } while(Get_Response() != ESP_OK);

 //****************************************************//
    UART1_Write_CText("Connection au Server  \r\n");
  do {
     //connected with ip addrss and used UDP protocol
     esp8266_Send(AT_CIPSERVER);
     new_line();
     wait_3sec();
  } while(Get_Response() != ESP_OK);
 //****************************************************//
}

// state machine  for Reading the data from UART in the interuppt routine
void esp8266_read_message()
{
    char esp_tmp;
    esp_tmp = UART_Rd_Ptr();    // Get received byte
    // echo sur terminal
    TXREG1=esp_tmp;
    // Process reception through state machine
    // words "OK" ,"ready","ERROR","FAIL","no change","+IPD" ,"CLOSED"
    switch (esp_state)
    {
      case 0: {
                esp_response = -1;                   // Clear response
                if (esp_tmp == 'O') //  // We have 'O', it could be "OK"
                  esp_state = 1;   // Expecting 'K'

                else if (esp_tmp == 'E') // // We have 'E', it could be "ERROR"
                  esp_state = 10;   // Expecting 'R'

                else if (esp_tmp == 'r') // // We have 'r', it could be "ready"
                  esp_state = 20;  // Expecting 'e'

                else if(esp_tmp == 'F') //// We have 'F', it could be "FAIL"
                  esp_state = 30;  // Expecting 'A'
         
            // rajout No change
            // 19:11:18.078> Step 2  Setting Station & AP mode =3.  AT+CWMODE=3
            //19:11:18.078>
            // 19:11:19.078> no change

                 else if(esp_tmp == 'n') //// We have 'n', it could be "no change"
                  esp_state = 40;  // Expecting 'o'

               else if (esp_tmp == '+') // // We have '+', it could be "+IPD"
                  esp_state = 100;  // Expecting 'I'
                  
             //  else if(esp_tmp=='>')      // caractere pour permettre l'envoi de la page Web
             //     {
             //      esp_response=ESP_SUP;
             //      esp_state =0;
             //      }
                    
                break;
              }

      case 1: {
                if (esp_tmp == 'K') // We have 'K', it could be "OK"
                {
                  esp_response = ESP_OK;// We have "OK" response
                  esp_state = 2;// Expecting CR+LF
                }
                else
                  esp_state = 0;  // reset operation
                break;
              }

      case 10: {
                if (esp_tmp == 'R') // We have 'R', it could be "ERROR"
                  esp_state = 11;
                else
                  esp_state = 0;
                break;
               }

      case 11: {
                if (esp_tmp == 'R') // We have 'R', it could be "ERROR"
                  esp_state = 12;
                else
                  esp_state = 0;
                break;
              }

      case 12: {
                if (esp_tmp == 'O') // We have 'O', it could be "ERROR"
                  esp_state = 13;
                else
                  esp_state = 0;
                break;
              }

      case 13: {
                if (esp_tmp == 'R') // We have 'R', it could be "ERROR"
                {
                  esp_response = ESP_ERROR;             // ERROR
                  esp_state = 2;
                }
                else
                  esp_state = 0;
                break;
               }

      case 20: {
                if (esp_tmp == 'e') // We have 'e', it could be "ready"
                  esp_state = 21;
                else
                  esp_state = 0;
                break;
              }

      case 21: {
                if (esp_tmp == 'a')// We have 'a', it could be "ready"
                  esp_state = 22;
                else
                  esp_state = 0;
                break;
               }

      case 22: {
                if (esp_tmp == 'd')// We have 'd', it could be "ready"
                  esp_state = 23;
                else
                  esp_state = 0;
                break;
               }


      case 23: {
                if (esp_tmp == 'y') // We have 'y', it could be "ready"
                  {
                  esp_response = ESP_READY;              // READY
                  esp_state = 2;
                 }
                else
                  esp_state = 0;
                break;
               }
     
      case 30: {
                if (esp_tmp == 'A') // // We have 'A', it could be "FAIL"
                  esp_state = 31;
                else
                  esp_state = 0;
                break;
               }

      case 31: {
                if (esp_tmp == 'I')
                  esp_state = 32;
                else
                  esp_state = 0;
                break;
              }

      case 32: {
                if (esp_tmp == 'L') // We have 'L', it could be "FAIL"
                {
                  esp_response = ESP_FAIL;              // FAIL
                  esp_state = 2;
                }
                else
                  esp_state = 0;
                break;
              }

        // it could be "no change"
        
          case 40: {
                if (esp_tmp == 'o') // We have 'o', it could be "no change"
                  esp_state = 41;
                else
                  esp_state = 0;
                break;
               }

          case 41: {
                if (esp_tmp == ' ')
                  esp_state = 42;
                else
                  esp_state = 0;
                break;
              }
          case 42: {
                if (esp_tmp == 'c')
                  esp_state = 43;
                else
                  esp_state = 0;
                break;
              }
           case 43: {
                if (esp_tmp == 'h')
                  esp_state = 44;
                else
                  esp_state = 0;
                break;
              }
           case 44: {
                if (esp_tmp == 'a')
                  esp_state = 45;
                else
                  esp_state = 0;
                break;
              }
            case 45: {
                if (esp_tmp == 'n')
                  esp_state = 46;
                else
                  esp_state = 0;
                break;
              }
            case 46: {
                if (esp_tmp == 'g')
                  esp_state = 47;
                else
                  esp_state = 0;
                break;
              }
          case 47: {
                if (esp_tmp == 'e')
                 {
                  esp_response = ESP_no_change;
                  esp_state = 2;
                  }
                   else
                  esp_state = 0;
                break;
              }

      // ----   traitement reponse  commamde via page Web ---------------
      case 100 : {   // We have 'I', it could be "+IPD"

                  if(esp_tmp == 'I')esp_state = 101;

                  else esp_state = 0;
                  break;
                }

      case 101 : {  // We have 'P', it could be "+IPD"
                  if(esp_tmp == 'P')esp_state = 102;

                  else esp_state = 0;
                  break;
                }
      case 102 : {  // We have 'D', it could be "+IPD"
                  if(esp_tmp == 'D')esp_state = 103;

                  else esp_state = 0;
                  break;
                }
      case 103 : {  // wait to read id the first
                  if(esp_tmp == ',' )
                   {
                    esp_state=104;
                   }

                  else esp_state=0;
                  break;
                }
      case 104 : {  // read id .
                   if(esp_tmp>='0' && esp_tmp<='5')
                    {
                     esp8266_id=esp_tmp-'0';
                     esp_state=105;
                    }
                  else esp_state=0;
                  break;
                }

       case 105 : {
           // on recoit 
           // +IPD,2,435:GET /?dev1=D4on HTTP/1.1
           // +IPD,1,335:GET /favicon.ico HTTP/1.1
                  if(esp_tmp !=':' )     // attente du :  avant le GET
                   {
                    esp_state=105;

                   }

                  else
                    {
                    // :GET /?Led1=D4on HTTP/1.1
                     // le : permet de definir l'origine 0 de la table
                     esp_i=0;
                     esp8266_received_data[0]=0; // reset esp8266_received_data for store new data
                     esp_DataReady_received=0;  // reset flag for compelete received data
                     esp_state=106;

                    }
                  break;
                }

      case 106 : { // isolation reponse apres l'apparition du :
                  //:GET /?Led1=D4on HTTP/1.1
                  // 1234567890123456
                  // attente de la fin du GET , soit le H de HTTP
                  if(esp_tmp !='H'  ) // wait until read 'H' from word "HTTP"
                   {
                    esp_i++;  // on se place de suite apres le :
                    if(esp_i>esp8266_rec_max)   // 16 cars
                      {
                        esp_i=esp8266_rec_max;
                       }
                     else
                     {
                      // tant qu'on ne rencontre pas le H de HTTP   et Nb <16
                      // on continue  stoker les caracteres suivants
                       esp8266_received_data[esp_i-1] = esp_tmp;
                     }
                   }
                  else
                      { 

                         // on a rencontr le H
                         //  donc commande recue completement
                         // on retrouve alors dans la table
                         //  GET /?Led1=D4on
                         esp_DataReady_received=1;
                         // on met un Zero fin de string  la place du H
                         // sinon on part en cacahute pour la suite du traitement!
                         esp8266_received_data[esp_i ]=0; //cloture du string
                         // la pertie utile se trouvera 6 carcateres plus loin que le debut
                         // GET /?Led1=D4on
                         // 123456
                         //       Led1=D4on
                         esp_state=0;
                      }
                   break;
                 }
      case 2: {

                if (esp_tmp == 13)esp_state = 3;
                else  esp_state = 0;
                break;
              }

      case 3: {
                if (esp_tmp == 10)
                {
                  esp_response_rcvd = 1;
                  esp_responseID = esp_response;
                 esp_state = 0;
                }
               else esp_state = 0;
                break;
             }

      default: {
                esp_state = 0;
                break;
              }
    }
 }